package b4a.example;


import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.ServiceHelper;
import anywheresoftware.b4a.debug.*;

public class widgetservice extends android.app.Service {
	public static class widgetservice_BR extends android.content.BroadcastReceiver {

		@Override
		public void onReceive(android.content.Context context, android.content.Intent intent) {
			android.content.Intent in = new android.content.Intent(context, widgetservice.class);
			if (intent != null)
				in.putExtra("b4a_internal_intent", intent);
			context.startService(in);
		}

	}
    static widgetservice mostCurrent;
	public static BA processBA;
    private ServiceHelper _service;
    public static Class<?> getObject() {
		return widgetservice.class;
	}
	@Override
	public void onCreate() {
        mostCurrent = this;
        if (processBA == null) {
		    processBA = new BA(this, null, null, "b4a.example", "b4a.example.widgetservice");
            try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            processBA.loadHtSubs(this.getClass());
            ServiceHelper.init();
        }
        _service = new ServiceHelper(this);
        processBA.service = this;
        processBA.setActivityPaused(false);
        if (BA.isShellModeRuntimeCheck(processBA)) {
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.widgetservice", processBA, _service);
		}
        BA.LogInfo("** Service (widgetservice) Create **");
        processBA.raiseEvent(null, "service_create");
        processBA.runHook("oncreate", this, null);
    }
		@Override
	public void onStart(android.content.Intent intent, int startId) {
		handleStart(intent);
    }
    @Override
    public int onStartCommand(android.content.Intent intent, int flags, int startId) {
    	handleStart(intent);
        processBA.runHook("onstartcommand", this, new Object[] {intent, flags, startId});
		return android.app.Service.START_NOT_STICKY;
    }
    private void handleStart(android.content.Intent intent) {
    	BA.LogInfo("** Service (widgetservice) Start **");
    	java.lang.reflect.Method startEvent = processBA.htSubs.get("service_start");
    	if (startEvent != null) {
    		if (startEvent.getParameterTypes().length > 0) {
    			anywheresoftware.b4a.objects.IntentWrapper iw = new anywheresoftware.b4a.objects.IntentWrapper();
    			if (intent != null) {
    				if (intent.hasExtra("b4a_internal_intent"))
    					iw.setObject((android.content.Intent) intent.getParcelableExtra("b4a_internal_intent"));
    				else
    					iw.setObject(intent);
    			}
    			processBA.raiseEvent(null, "service_start", iw);
    		}
    		else {
    			processBA.raiseEvent(null, "service_start");
    		}
    	}
    }
	@Override
	public android.os.IBinder onBind(android.content.Intent intent) {
		return null;
	}
	@Override
	public void onDestroy() {
        BA.LogInfo("** Service (widgetservice) Destroy **");
		processBA.raiseEvent(null, "service_destroy");
        processBA.service = null;
		mostCurrent = null;
		processBA.setActivityPaused(true);
        processBA.runHook("ondestroy", this, null);
	}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.RemoteViewsWrapper _rv = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public b4a.example.main _main = null;
  public Object[] GetGlobals() {
		return new Object[] {"Main",Debug.moduleToString(b4a.example.main.class),"Rv",_rv,"Service",mostCurrent._service,"Timer1",_timer1};
}
public static String  _img_click() throws Exception{
try {
		Debug.PushSubsStack("Img_Click (widgetservice) ","widgetservice",1,processBA,mostCurrent,50);
 BA.debugLineNum = 50;BA.debugLine="Sub Img_Click";
Debug.ShouldStop(131072);
 BA.debugLineNum = 52;BA.debugLine="Rv.SetVisible(\"Img\" , False)";
Debug.ShouldStop(524288);
_rv.SetVisible(processBA,"Img",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 53;BA.debugLine="Rv.SetVisible(\"Img2\" , True)";
Debug.ShouldStop(1048576);
_rv.SetVisible(processBA,"Img2",anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 55;BA.debugLine="Rv.UpdateWidget";
Debug.ShouldStop(4194304);
_rv.UpdateWidget(processBA);
 BA.debugLineNum = 57;BA.debugLine="End Sub";
Debug.ShouldStop(16777216);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _img2_click() throws Exception{
try {
		Debug.PushSubsStack("Img2_Click (widgetservice) ","widgetservice",1,processBA,mostCurrent,59);
 BA.debugLineNum = 59;BA.debugLine="Sub Img2_Click";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 61;BA.debugLine="Rv.SetVisible(\"Img2\" , False)";
Debug.ShouldStop(268435456);
_rv.SetVisible(processBA,"Img2",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 62;BA.debugLine="Rv.SetVisible(\"Img\" , True)";
Debug.ShouldStop(536870912);
_rv.SetVisible(processBA,"Img",anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 64;BA.debugLine="Rv.UpdateWidget";
Debug.ShouldStop(-2147483648);
_rv.UpdateWidget(processBA);
 BA.debugLineNum = 68;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 5;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 9;BA.debugLine="Dim Rv As RemoteViews";
_rv = new anywheresoftware.b4a.objects.RemoteViewsWrapper();
 //BA.debugLineNum = 10;BA.debugLine="Dim Timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 12;BA.debugLine="End Sub";
return "";
}
public static String  _rv_disabled() throws Exception{
try {
		Debug.PushSubsStack("Rv_Disabled (widgetservice) ","widgetservice",1,processBA,mostCurrent,39);
 BA.debugLineNum = 39;BA.debugLine="Sub Rv_Disabled";
Debug.ShouldStop(64);
 BA.debugLineNum = 40;BA.debugLine="StopService(\"\")";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.StopService(processBA,(Object)(""));
 BA.debugLineNum = 41;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _rv_requestupdate() throws Exception{
try {
		Debug.PushSubsStack("Rv_RequestUpdate (widgetservice) ","widgetservice",1,processBA,mostCurrent,31);
 BA.debugLineNum = 31;BA.debugLine="Sub Rv_RequestUpdate";
Debug.ShouldStop(1073741824);
 BA.debugLineNum = 33;BA.debugLine="Rv.SetText(\"Label2\" , DateTime.Time(DateTime.Now)";
Debug.ShouldStop(1);
_rv.SetText(processBA,"Label2",anywheresoftware.b4a.keywords.Common.DateTime.Time(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 BA.debugLineNum = 34;BA.debugLine="Rv.UpdateWidget";
Debug.ShouldStop(2);
_rv.UpdateWidget(processBA);
 BA.debugLineNum = 36;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _service_create() throws Exception{
try {
		Debug.PushSubsStack("Service_Create (widgetservice) ","widgetservice",1,processBA,mostCurrent,14);
 BA.debugLineNum = 14;BA.debugLine="Sub Service_Create";
Debug.ShouldStop(8192);
 BA.debugLineNum = 15;BA.debugLine="Rv = ConfigureHomeWidget(\"LW\" , \"Rv\" , 30 , \"ویجت";
Debug.ShouldStop(16384);
_rv = anywheresoftware.b4a.objects.RemoteViewsWrapper.createRemoteViews(processBA, R.layout.widgetservice_layout, "LW","Rv");
 BA.debugLineNum = 16;BA.debugLine="Timer1.Initialize(\"Timer1\" , 5000)";
Debug.ShouldStop(32768);
Debug.DebugWarningEngine.CheckInitialize(_timer1);_timer1.Initialize(processBA,"Timer1",(long) (5000));
 BA.debugLineNum = 17;BA.debugLine="Timer1.Enabled = True";
Debug.ShouldStop(65536);
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 20;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _service_destroy() throws Exception{
try {
		Debug.PushSubsStack("Service_Destroy (widgetservice) ","widgetservice",1,processBA,mostCurrent,72);
 BA.debugLineNum = 72;BA.debugLine="Sub Service_Destroy";
Debug.ShouldStop(128);
 BA.debugLineNum = 74;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _service_start(anywheresoftware.b4a.objects.IntentWrapper _startingintent) throws Exception{
try {
		Debug.PushSubsStack("Service_Start (widgetservice) ","widgetservice",1,processBA,mostCurrent,22);
Debug.locals.put("StartingIntent", _startingintent);
 BA.debugLineNum = 22;BA.debugLine="Sub Service_Start (StartingIntent As Intent)";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 24;BA.debugLine="If Rv.HandleWidgetEvents(StartingIntent) Then";
Debug.ShouldStop(8388608);
if (_rv.HandleWidgetEvents(processBA,(android.content.Intent)(_startingintent.getObject()))) { 
 BA.debugLineNum = 25;BA.debugLine="Return";
Debug.ShouldStop(16777216);
if (true) return "";
 };
 BA.debugLineNum = 28;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _timer1_tick() throws Exception{
try {
		Debug.PushSubsStack("Timer1_Tick (widgetservice) ","widgetservice",1,processBA,mostCurrent,45);
 BA.debugLineNum = 45;BA.debugLine="Sub Timer1_Tick";
Debug.ShouldStop(4096);
 BA.debugLineNum = 46;BA.debugLine="Rv.SetText(\"Label2\" , DateTime.Time(DateTime.Now)";
Debug.ShouldStop(8192);
_rv.SetText(processBA,"Label2",anywheresoftware.b4a.keywords.Common.DateTime.Time(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 BA.debugLineNum = 47;BA.debugLine="Rv.UpdateWidget";
Debug.ShouldStop(16384);
_rv.UpdateWidget(processBA);
 BA.debugLineNum = 48;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
}
